#include "Point.h"
#include "Sprite.h"
#include "Main.h"
#include "Vram.h"

constexpr byte Count = 4;

constexpr byte Time = 6;
constexpr byte InvalidY = 0xff;
static const word[] Values = { 10, 20, 40, 80 };

Point[Count] Points;


void InitPoints()
{
    ptr<Point> pPoint;
    for (pPoint: Points) {
        pPoint->y = InvalidY;
    }
}


void StartPoint(byte x, byte y, byte rate)
{
    ptr<Point> pPoint;
    AddScore(Values[rate]);
    for (pPoint: Points) {
        if (pPoint->y != InvalidY) continue;
        pPoint->x = x;
        pPoint->y = y;
        pPoint->clock = Time << CoordShift;
        pPoint->rate = rate;
        return;
    }
}


void UpdatePoints()
{
    ptr<Point> pPoint;
    for (pPoint: Points) {
        if (pPoint->y == InvalidY) continue;
        if (pPoint->clock == 0) {
            pPoint->y = InvalidY;
        }
        else {
            --pPoint->clock;
        }
    }
}


void DrawPoints()
{
    static const word[] Offsets = {
        VramRowSize * 1,
        VramRowSize * 2,
        VramRowSize * 2,
        VramRowSize * 3,
        VramRowSize * 4,
        VramRowSize * 4,
        VramRowSize * 5,
        VramRowSize * 6,
        VramRowSize * 6,
        VramRowSize * 7,
        VramRowSize * 8,
        VramRowSize * 8,
        VramRowSize * 9,
        VramRowSize * 10,
        VramRowSize * 10,
        VramRowSize * 11,
        VramRowSize * 12,
        VramRowSize * 12,
        VramRowSize * 13,
        VramRowSize * 14,
        VramRowSize * 14,
        VramRowSize * 15,
    };
    static const byte[] Numbers = { '1', '2', '4', '8' };
    ptr<Point> pPoint;
    for (pPoint: Points) {
        if (pPoint->y != InvalidY) {
            ptr<byte> pVram;
            pVram = Vram + Offsets[pPoint->y] + (pPoint->x << 1);
            *pVram = Numbers[pPoint->rate];
            ++pVram;
            *pVram = '0';
            ++pVram;
            *pVram = '0';
        }
    }
}